## systemimager-ssh 3.2.3-4

=== Makefile ===
#
# "SystemImager"  
#
#   Copyright (C) 1999-2004 Brian Elliott Finley
#   Copyright (C) 2001-2002 Hewlett-Packard Company <dannf@fc.hp.com>
#
#   Others who have contributed to this code:
#   Sean Dague <sean@dague.net>
#
#   $Id: Makefile,v 1.154.4.2 2004/04/13 16:40:50 brianfinley Exp $
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# 2004.04.13 Brian Elliott Finley
# - Michael Jennings suggested permissions changes on some files.  done.
#
#
# ERRORS when running make:
#   If you encounter errors when running "make", because make couldn't find
#   certain things that it needs, and you are fortunate enough to be building
#   on a Debian system, you can issue the following command to ensure that
#   all of the proper tools are installed.
#
#   On Debian, "apt-get build-dep systemimager ; apt-get install wget", will 
#   install all the right tools.  Note that you need the deb-src entries in 
#   your /etc/apt/sources.list file.
#
#
# SystemImager file location standards:
#   o images will be stored in: /var/lib/systemimager/images/
#   o autoinstall scripts:      /var/lib/systemimager/scripts/
#   o override directories:     /var/lib/systemimager/overrides/
#
#   o web gui pages:            /usr/share/systemimager/web-gui/
#
#   o kernels:                  /usr/share/systemimager/boot/`arch`/flavor/
#   o initrd.img:               /usr/share/systemimager/boot/`arch`/flavor/
#   o boel_binaries.tar.gz:     /usr/share/systemimager/boot/`arch`/flavor/
#
#   o perl libraries:           /usr/lib/systemimager/perl/
#
#   o docs:                     Use distribution appropriate location.
#                               Defaults to /usr/share/doc/systemimager/ 
#                               for installs from tarball or source.
#
#   o man pages:                /usr/share/man/man8/
#
#   o log files:                /var/log/systemimager/
#
#   o configuration files:      /etc/systemimager/
#   o rsyncd.conf:              /etc/systemimager/rsyncd.conf
#   o rsyncd init script:       /etc/init.d/systemimager
#   o netbootmond init script:  /etc/init.d/netbootmond
#   
#   o tftp files will be copied to the appropriate destination (as determined
#     by the local SysAdmin when running "mkbootserver".
#
#   o user visible binaries:    /usr/bin
#     (lsimage, mkautoinstalldiskette, mkautoinstallcd)
#   o sysadmin binaries:        /usr/sbin
#     (all other binaries)
#
# Standards for pre-defined rsync modules:
#   o boot (directory that holds architecture specific directories with
#           boot files for clients)
#   o overrides
#   o scripts
#
# To include the ctcs test suite, and associated files, do a 'make WITH_CTCS=1 all'
#

DESTDIR =
VERSION = $(shell cat VERSION)

## is this an unstable release?
MINOR = $(shell echo $(VERSION) | cut -d "." -f 2)
UNSTABLE = 0
ifeq ($(shell echo "$(MINOR) % 2" | bc),1)
UNSTABLE = 1
endif

FLAVOR = $(shell cat FLAVOR)

TOPDIR  := $(CURDIR)

# RELEASE_DOCS are toplevel files that should be included with all posted
# tarballs, but aren't installed onto the destination machine by default
RELEASE_DOCS = CHANGE.LOG COPYING CREDITS ERRATA README VERSION

# should we be messing with the user's PATH? -dannf
PATH = /sbin:/bin:/usr/sbin:/usr/bin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin
ARCH = $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Follows is a set of arch manipulations to distinguish between ppc types
ifeq ($(ARCH),ppc64)
IS_PPC64 := 1
ifneq ($(shell ls /proc/iSeries 2>/dev/null),)
        ARCH := ppc64-iSeries
endif
endif

ifneq ($(BUILD_ARCH),)
	ARCH := $(BUILD_ARCH)
endif

MANUAL_DIR = $(TOPDIR)/doc/manual_source
MANPAGE_DIR = $(TOPDIR)/doc/man
PATCH_DIR = $(TOPDIR)/patches
LIB_SRC = $(TOPDIR)/lib
SRC_DIR = $(TOPDIR)/src
BINARY_SRC = $(TOPDIR)/sbin

# destination directories
PREFIX = /usr
ETC  = $(DESTDIR)/etc
INITD = $(ETC)/init.d
USR = $(DESTDIR)$(PREFIX)
DOC  = $(USR)/share/doc/systemimager-doc
BIN = $(USR)/bin
SBIN = $(USR)/sbin
MAN8 = $(USR)/share/man/man8
LIB_DEST = $(USR)/lib/systemimager/perl
LOG_DIR = $(DESTDIR)/var/log/systemimager
LOCK_DIR = $(DESTDIR)/var/lock/systemimager

INITRD_DIR = $(TOPDIR)/initrd_source

BOOT_BIN_DEST     = $(USR)/share/systemimager/boot/$(ARCH)/$(FLAVOR)

SSH_BIN_DEST 	  = $(USR)/share/systemimager/boot/$(ARCH)/ssh

PXE_CONF_SRC      = etc/pxelinux.cfg
PXE_CONF_DEST     = $(ETC)/systemimager/pxelinux.cfg

BINARIES := mkautoinstallcd mkautoinstalldiskette
SBINARIES := addclients cpimage getimage mkdhcpserver mkdhcpstatic mkautoinstallscript mkbootserver mvimage pushupdate rmimage mkrsyncd_conf mkclientnetboot netbootmond imagemanip mkbootpackage
CLIENT_SBINARIES  := updateclient prepareclient
COMMON_BINARIES   = lsimage

IMAGESRC    = $(TOPDIR)/var/lib/systemimager/images
IMAGEDEST   = $(DESTDIR)/var/lib/systemimager/images
WARNING_FILES = $(IMAGESRC)/README $(IMAGESRC)/CUIDADO $(IMAGESRC)/ACHTUNG
AUTOINSTALL_SCRIPT_DIR = $(DESTDIR)/var/lib/systemimager/scripts
OVERRIDES_DIR = $(DESTDIR)/var/lib/systemimager/overrides
OVERRIDES_README = $(TOPDIR)/var/lib/systemimager/overrides/README
FLAMETHROWER_STATE_DIR = $(DESTDIR)/var/state/systemimager/flamethrower

RSYNC_STUB_DIR = $(ETC)/systemimager/rsync_stubs

CHECK_FLOPPY_SIZE = expr \`du -b $(INITRD_DIR)/initrd.img | cut -f 1\` + \`du -b $(LINUX_IMAGE) | cut -f 1\`

BOEL_BINARIES_DIR = $(TOPDIR)/tmp/boel_binaries
BOEL_BINARIES_TARBALL = $(BOEL_BINARIES_DIR).tar.gz

SYSTEMIMAGER_SSH_DIR = $(TOPDIR)/tmp/systemimager_ssh
SYSTEMIMAGER_SSH_TARBALL = $(SYSTEMIMAGER_SSH_DIR).tar.gz

SI_INSTALL = $(TOPDIR)/tools/si_install --si-prefix=$(PREFIX)
GETSOURCE = $(TOPDIR)/tools/getsource

PYTHON = $(shell which python2 || which python)

# build everything, install nothing
PHONY += all
all:	$(BOEL_BINARIES_TARBALL) kernel $(INITRD_DIR)/initrd.img manpages

arch:
	echo $(ARCH)
	echo $(IS_PPC64)

binaries: $(BOEL_BINARIES_TARBALL) kernel $(INITRD_DIR)/initrd.img

# All has been modified as docs don't build on non debian platforms
#
#all:	$(BOEL_BINARIES_TARBALL) kernel $(INITRD_DIR)/initrd.img docs manpages

# Now include the other targets
# This has to be right after all to make all the default target
include $(TOPDIR)/make.d/*.rul $(INITRD_DIR)/initrd.rul

# a complete server install
PHONY += install_server_all
install_server_all:	install_server install_common install_binaries

# a complete client install
PHONY += install_client_all
install_client_all:	install_client install_common

# install server-only architecture independent files
PHONY += install_server
install_server:	install_server_man install_configs install_server_libs
	$(SI_INSTALL) -d $(BIN)
	$(SI_INSTALL) -d $(SBIN)
	$(foreach binary, $(BINARIES), \
		$(SI_INSTALL) -m 755 $(BINARY_SRC)/$(binary) $(BIN);)
	$(foreach binary, $(SBINARIES), \
		$(SI_INSTALL) -m 755 $(BINARY_SRC)/$(binary) $(SBIN);)
	$(SI_INSTALL) -d -m 755 $(LOG_DIR)
	$(SI_INSTALL) -d -m 755 $(LOCK_DIR)
	$(SI_INSTALL) -d -m 755 $(BOOT_BIN_DEST)
	$(SI_INSTALL) -d -m 755 $(AUTOINSTALL_SCRIPT_DIR)
	$(SI_INSTALL) -d -m 755 $(OVERRIDES_DIR)
	$(SI_INSTALL) -m 644 $(OVERRIDES_README) $(OVERRIDES_DIR)

	$(SI_INSTALL) -d -m 755 $(PXE_CONF_DEST)
	$(SI_INSTALL) -m 644 --backup --text $(PXE_CONF_SRC)/message.txt \
		$(PXE_CONF_DEST)/message.txt
	$(SI_INSTALL) -m 644 --backup $(PXE_CONF_SRC)/syslinux.cfg \
		$(PXE_CONF_DEST)/syslinux.cfg
	$(SI_INSTALL) -m 644 --backup $(PXE_CONF_SRC)/syslinux.cfg.localboot \
		$(PXE_CONF_DEST)/syslinux.cfg.localboot
	$(SI_INSTALL) -m 644 --backup $(PXE_CONF_SRC)/syslinux.cfg.localboot \
		$(PXE_CONF_DEST)/default

	$(SI_INSTALL) -d -m 755 $(IMAGEDEST)
	$(SI_INSTALL) -m 644 $(WARNING_FILES) $(IMAGEDEST)
	cp -a $(IMAGEDEST)/README $(IMAGEDEST)/DO_NOT_TOUCH_THESE_DIRECTORIES

	$(SI_INSTALL) -d -m 755 $(FLAMETHROWER_STATE_DIR)

# install client-only files
PHONY += install_client
install_client: install_client_man install_client_libs
	mkdir -p $(ETC)/systemimager
	$(SI_INSTALL) -b -m 644 etc/updateclient.local.exclude \
	  $(ETC)/systemimager
	$(SI_INSTALL) -b -m 644 etc/client.conf \
	  $(ETC)/systemimager
	mkdir -p $(SBIN)

	$(foreach binary, $(CLIENT_SBINARIES), \
		$(SI_INSTALL) -m 755 $(BINARY_SRC)/$(binary) $(SBIN);)

# install files common to both the server and client
PHONY += install_common
install_common:	install_common_man install_common_libs
	mkdir -p $(BIN)
	$(foreach binary, $(COMMON_BINARIES), \
		$(SI_INSTALL) -m 755 $(BINARY_SRC)/$(binary) $(BIN);)

# install server-only libraries
PHONY += install_server_libs
install_server_libs:
	mkdir -p $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 644 $(LIB_SRC)/SystemImager/Server.pm $(LIB_DEST)/SystemImager

# install client-only libraries
PHONY += install_client_libs
install_client_libs:
	mkdir -p $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 644 $(LIB_SRC)/SystemImager/Client.pm $(LIB_DEST)/SystemImager

# install common libraries
PHONY += install_common_libs
install_common_libs:
	mkdir -p $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 644 $(LIB_SRC)/SystemImager/Common.pm $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 644 $(LIB_SRC)/SystemImager/Options.pm $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 644 $(LIB_SRC)/SystemImager/Config.pm $(LIB_DEST)/SystemImager
	$(SI_INSTALL) -m 755 $(LIB_SRC)/confedit $(LIB_DEST)

# checks the sized of the i386 kernel and initrd to make sure they'll fit 
# on an autoinstall diskette
PHONY += check_floppy_size
check_floppy_size:	$(LINUX_IMAGE) $(INITRD_DIR)/initrd.img
ifeq ($(ARCH), i386)
	@### see if the kernel and ramdisk are larger than the size of a 1.44MB
	@### floppy image, minus about 10k for syslinux stuff
	@echo -n "Ramdisk + Kernel == "
	@echo "`$(CHECK_FLOPPY_SIZE)`"
	@echo "                    1454080 is the max that will fit."
	@[ `$(CHECK_FLOPPY_SIZE)` -lt 1454081 ] || \
	     (echo "" && \
	      echo "************************************************" && \
	      echo "Dammit.  The kernel and ramdisk are too large.  " && \
	      echo "************************************************" && \
	      exit 1)
	@echo " - ok, that should fit on a floppy"
endif

# install the initscript & config files for the server
PHONY += install_configs
install_configs:
	$(SI_INSTALL) -d $(ETC)/systemimager
	$(SI_INSTALL) -m 644 etc/systemimager.conf $(ETC)/systemimager/
	$(SI_INSTALL) -m 644 etc/flamethrower.conf $(ETC)/systemimager/
	$(SI_INSTALL) -m 644 etc/autoinstallscript.template $(ETC)/systemimager/
	$(SI_INSTALL) -m 644 etc/imagemanip.conf $(ETC)/systemimager/
	$(SI_INSTALL) -m 644 etc/imagemanip.perm $(ETC)/systemimager/

	mkdir -p $(RSYNC_STUB_DIR)
	$(SI_INSTALL) -b -m 644 etc/rsync_stubs/10header $(RSYNC_STUB_DIR)
	[ -f $(RSYNC_STUB_DIR)/99local ] \
		&& $(SI_INSTALL) -b -m 644 etc/rsync_stubs/99local $(RSYNC_STUB_DIR)/99local.dist~ \
		|| $(SI_INSTALL) -b -m 644 etc/rsync_stubs/99local $(RSYNC_STUB_DIR)
	$(SI_INSTALL) -b -m 644 etc/rsync_stubs/README $(RSYNC_STUB_DIR)

	[ "$(INITD)" != "" ] || exit 1
	mkdir -p $(INITD)
	$(SI_INSTALL) -b -m 755 etc/init.d/systemimager-server-rsyncd 			$(INITD)
	$(SI_INSTALL) -b -m 755 etc/init.d/systemimager-server-netbootmond 		$(INITD)
	$(SI_INSTALL) -b -m 755 etc/init.d/systemimager-server-flamethrowerd 	$(INITD)

########## END initrd ##########


########## BEGIN man pages ##########
# build all of the manpages
PHONY += manpages
manpages:
	$(MAKE) -C $(MANPAGE_DIR) TOPDIR=$(TOPDIR)

=== doc/man/Makefile ===
#
# "SystemImager"
#
#  Copyright (C) 2002 Hewlett-Packard Company <dannf@fc.hp.com>
#  Copyright (C) 2002 Bald Guy Software <brian.finley@baldguysoftware.com>
#
#    $Id: Makefile,v 1.20 2003/11/13 00:11:31 brianfinley Exp $
#


DESTDIR = 
PREFIX = /usr
USR = $(DESTDIR)$(PREFIX)

SYSTEMIMAGER_VERSION = $(shell cat ../../VERSION)

MANPAGES = $(SERVER_MAN) $(CLIENT_MAN) $(COMMON_MAN)

SERVER_MAN = addclients.8 				\
			getimage.8					\
			mkautoinstallcd.8			\
			mkautoinstalldiskette.8		\
			mkautoinstallscript.8		\
			mkdhcpserver.8				\
			mkdhcpstatic.8				\
			cpimage.8					\
			mvimage.8					\
			rmimage.8					\
			mkbootserver.8				\
			systemimager.conf.5			\
			systemimager-rsyncd.conf.5	\
			mkrsyncd_conf.8				\
			pushupdate.8				\
			mkclientnetboot.8			
#			imagemanip.8

CLIENT_MAN = prepareclient.8 updateclient.8

COMMON_MAN = autoinstallscript.conf.5 lsimage.8

.SUFFIXES: .5 .8 .8.gz .5.gz .pod .sgml

all:	compress

%.gz:	%
	gzip -9 < $< > $@

systemimager.conf.5:	systemimager.conf.pod
	pod2man --release=$(SYSTEMIMAGER_VERSION) -s 5 -c "SystemImager" $< $@

systemimager-rsyncd.conf.5:	systemimager-rsyncd.conf.pod
	pod2man --release=$(SYSTEMIMAGER_VERSION) -s 5 -c "SystemImager" $< $@

imagemanip.8:	$(TOPDIR)/sbin/imagemanip
	pod2man --release=$(SYSTEMIMAGER_VERSION) -s 8 -c "SystemImager" $< $@

%.5 %.8:	%.sgml %.content.sgml
	docbook2man $<
	mv $(shell echo $@ | tr '[:lower:]' '[:upper:]') $@

install_all:	install_common_man install_server_man install_client_man

manpages:	$(MANPAGES)

compress:	$(foreach file, $(MANPAGES), $(file).gz)

install_common_man:	$(foreach file, $(COMMON_MAN), $(file).gz)
	$(foreach manpage, $(COMMON_MAN), \
	  install -D -m 644 $(manpage).gz \
	    $(USR)/share/man/man`echo $(manpage) | \
	    sed 's/.*\(.\)$$/\1/'`/$(manpage).gz ;)

install_server_man:	$(foreach file, $(SERVER_MAN), $(file).gz)
	$(foreach manpage, $(SERVER_MAN), \
	  install -D -m 644 $(manpage).gz \
	    $(USR)/share/man/man`echo $(manpage) | \
	    sed 's/.*\(.\)$$/\1/'`/$(manpage).gz ;)

install_client_man:	$(foreach file, $(CLIENT_MAN), $(file).gz)
	$(foreach manpage, $(CLIENT_MAN), \
	  install -D -m 644 $(manpage).gz \
	    $(USR)/share/man/man`echo $(manpage) | \
	    sed 's/.*\(.\)$$/\1/'`/$(manpage).gz ;)

clean:
	rm -f *~ \#*\# *.8 *.5 *.gz manpage.links manpage.refs

=== debian/changelog ===
systemimager-ssh (3.2.3-4) unstable; urgency=high
  
  * Remove hardcoded libnss paths in make.d/openssh.rul with
    openssh.libnssfix.patch.  Thanks to Isaac Clerencia.  Closes: #274551

 -- dann frazier <dannf@debian.org>  Tue, 05 Oct 2004 09:08:30 -0600

systemimager-ssh (3.2.3-3) unstable; urgency=medium
  
  * Really add python as a build-dep (make control file generation
    part of the clean rule.  Closes: #261054

 -- dann frazier <dannf@debian.org>  Tue, 10 Aug 2004 22:08:37 -0600

systemimager-ssh (3.2.3-2) unstable; urgency=low
  
  * Add python as a build-dep.  Closes: #261054

 -- dann frazier <dannf@debian.org>  Sat, 31 Jul 2004 13:52:24 -0600

systemimager-ssh (3.2.3-1) unstable; urgency=low
  
  * new upstream release; move to single source package.
    - x86 package now installable. Closes: #240531
    - ia64 package now installable. Closes: #240538
	
 -- dann frazier <dannf@debian.org>  Wed, 14 Jul 2004 22:38:37 -0600

=== debian/control ===
Source: systemimager-ssh
Section: admin
Priority: optional
Maintainer: dann frazier <dannf@debian.org>
Build-Depends-Indep: bzip2, debhelper (>> 2.0.0), libssl-dev, python, zlib1g-dev
Build-Conflicts: libc6-pic, libc6.1-pic
Standards-Version: 3.5.7

Package: systemimager-ssh-i386
Architecture: all
Depends: systemimager-boot-i386-standard (>= 3.2.0), systemimager-boot-i386-standard (<< 3.3.0)
Description: SystemImager boot binaries for i386 client nodes
 SystemImager is a set of utilities for installing GNU/Linux disk images to
 client machines over the network.  Images are stored in flat
 files on the server, making updates easy.  The rsync protocol is used for 
 transfers, making updates efficient.
 .
 This provides an optional ssh component for the image server, which 
 adds the ability to do secure, automated installs.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

NAME = systemimager-ssh
ARCH = $(shell dpkg --print-architecture)
PKG = $(NAME)-$(ARCH)
VERSION = $(shell dpkg-parsechangelog | grep ^Version: | \
                  cut -d " " -f 2 | cut -d "-" -f 1)
BUILD_DIR = $(NAME)-$(VERSION)
UPSTREAM_TARBALL = $(NAME)-$(VERSION).tar.bz2


PATCHES=$(sort $(shell find $(CURDIR)/patches -name "*.patch"))

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	@echo -n "Extracting upstream tarball..."
	@tar xfj $(UPSTREAM_TARBALL)
	@echo "done."
	@cd $(BUILD_DIR) && \
          $(foreach patch, $(PATCHES), \
            echo -n Applying `basename $(patch)`... && cat $(patch) | \
	    patch -s -p1 && echo done. &&) /bin/true
	touch configure-stamp

copy_changelog:	$(BUILD_DIR)/changelog

$(BUILD_DIR)/changelog:	$(BUILD_DIR)/CHANGE.LOG
	cd $(BUILD_DIR) && cp CHANGE.LOG changelog

build:	build-arch build-indep

build-indep:	cleandeb configure-stamp build-indep-stamp copy_changelog

build-indep-stamp:
# nothing to do
	touch build-indep-stamp

build-arch:	cleandeb configure-stamp build-arch-stamp copy_changelog

build-arch-stamp:
	dh_testdir

	$(MAKE) -C $(BUILD_DIR) WITH_SSH=1 ssh_tarball

	touch build-arch-stamp

debian/control:
	sed -e 's/$${misc\:Package\-Arch}/$(ARCH)/g' \
	    -e 's/$${misc\:Real\-Arch}/all/;' \
	       debian/control.in > debian/control

clean:	debian/control
	dh_testdir
	dh_testroot
	rm -f build-indep-stamp build-arch-stamp configure-stamp

	# Add here commands to clean up after the build process.
	rm -rf $(BUILD_DIR)
	cd $(CURDIR)/debian && rm -rf $(PKG)
	dh_clean

install-arch:	build-arch
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(CURDIR)/debian && mkdir -p $(PKG)

	# Add here commands to install the packages
	$(MAKE) -C $(BUILD_DIR) install_ssh_tarball \
	  DESTDIR=$(CURDIR)/debian/$(PKG) PREFIX=/usr WITH_SSH=1

install-indep:	build-indep
# We have nothing to do by default

# Build architecture-dependent files here.
binary-arch: build-arch install-arch
	dh_testdir
	dh_testroot
	# generate control file suitable for the boot package
	# substvars don't seem to work, so we hack around it with sed.
	cp debian/control debian/control.orig
	dh_installdocs
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums 
	dh_builddeb

# Build architecture-independent files here.
binary-indep: build-indep install-indep
# We have nothing to do by default

binary: binary-indep binary-arch
.PHONY: build cleandeb clean binary-indep binary-arch binary install configure debian/control
